Version 3.12.0-2, April/May 2026
* Move from domain xs4all.nl to new domain algol68genie.nl.
* Minor fixes.

Version 3.11.0-3, March/April 2026
* Improves STRING handling.
* Minor fixes.
* Documentation updates.
* Adds environment enquiry "eof char".
* Adds operators CEIL, FIX, FLOOR, FRAC and TRUNC.

Version 3.10.0-14, October 2025/March 2026
* Adds procedure "https time out" to manage waiting for unresponsive URLs.
* Adds procedure "append", analogous to "open" but to append at EOF.
* Fixes IO time out occuring on some platforms.
* Supersedes WIN32 prebuilt binary by WIN64 prebuilt binary.
* Introduces raw reading of the terminal.
* Introduces functions "raw", "cooked" and "peek char".
* Minor fixes.
* Documentation updates.

Version 3.9.0-10, September/October 2025
* Lift 2GB maximum heap size restriction.
* Make available WIN64 prebuilt binary.
* Minor fixes.

Version 3.8.0-7, August/September 2025
* Notices replace selected warnings.
  + A warning signals a potential runtime problem.
  + A notice is a remark on the code.
* Minor fixes.

Version 3.7.0-7, August 2025
* Improved garbage collector.
* Minor fixes.

Version 3.6.0-2, July/August 2025
* Updated diagnostic messages.
* Documentation updates.
* Minor fixes.

Version 3.5.0-15, February 2024/June 2025
* Write diagnostics to stderr instead of stdout.
* Minor fix to configuration on Gentoo, OpenBSD and Fedora.
* Minor fixes.

Version 3.4.0-7, October 2023/January 2024
* Fix Darwin configuration issue.
* Enable plugin compiler on Apple Silicon Macs.
* C17 compliant code.
* Procedure "http content" now requires libcurl.
* Procedure "tcp request" is deprecated.
* Minor fixes.

Version 3.3.1-24, August/September 2023
* Fix configuration issue for 32-bit systems.
* Minor fixes.
* Distribution updates.

Version 3.3.0, August 2023
* Minor fixes.
* Add procedure "https content" (UNIX).
* Add procedures "puts", "gets", "putsf", "getsf" and
  "string", "stringf".

Version 3.2.1, July 2023
* Minor fixes.
* Distribution updates.

Version 3.2.0, June 2023
* Enable CLANG as (optional) back-end plugin compiler, as alternative for GCC.

Version 3.1.1-3.1.9, January/May 2023
* Fix configuration bug preventing building on Cygwin.
* Fix undefined errno upon succesful relpath call on some systems.
* Distribution update.
* Minor bug fixes.

Version 3.1.0, November 2022
* Fix several bugs reported for 3.0.0-8.
* Apply several OS dependent patches reported for 3.0.0-8.
* READ and INCLUDE relative to the source file, not the present working directory.
  This conforms to the C preprocessor standard.

Versions 3.0.1-8, January/September 2022
* Fix several bugs reported for 3.0.0-7.
* Apply several OS dependent patches reported for 3.0.0-7.
* Update a68g.exe to GSL 2.7.1 and R mathlib 4.1.2.

Version 3.0.0, December 2021
* On platforms that support them: 64 bit INT/BITS and 128-bit LONG INT, LONG BITS and LONG REAL.
  These platforms include amd64, x86_64 and i386 with GCC.
* More bindings for routines from the GNU Scientific Library.
* Add a generalized incomplete gamma function.
* Build with R mathlib bindings, if available.
* Fix several minor bugs.

Version 2.8.4, November 2016
* Fix several minor bugs.

Version 2.8.3, March 2016
* Fix garbage collector bug.
* Fix "execve output" that caused a "too many open files" type error.
* Fix ncurses support on Ubuntu.

Version 2.8.2, October 2015
* Several bug fixes.
* Cleaner interface for command line arguments 
  through routines a68gargc and a68gargv.

Version 2.8.1, January 2015
* Update source code for recent versions of gcc, autoconf, automake and TeX.
* Documentation updates.

Version 2.8, October 2013
* Fix build issue on ARM.
* Fix reported bugs in version 2.7.

Version 2.7, June 2013
* Larger test set.
* Fix reported bugs in version 2.6.

Version 2.6, November 2012
* Larger test set.
* Hyperlinked manual.
* Fix reported bugs in version 2.5.

Version 2.5, October 2012
* FHS 2.3 compliant.
* Larger test set.
* Fix minor issues.
* Add routine "abend" (exits with runtime error).

Version 2.4.1, June 2012
* Fix issue in transput library.
* Fix issue in garbage collector.
* Documentation updates.
* Better distribution lay-out.

Version 2.4, June 2012
* Add pretty-printer.
* Simplified garbage collector.
* Add procedure "read line" (calls GNU readline).
* Add procedure "on gc event".
* Add option --storage [=] n.
* Fix error in option --handles.
* Removed the field-selector extension.

Version 2.3.9, April 2012
* Fix curses build issue.
* Documentation updates.

Version 2.3.8, April 2012
* Fix build issues on Solaris and Cygwin.
* Add procedures "rows" and "columns".
* Documentation updates.

Version 2.3.7, February 2012
* Fix build issue occuring on some platforms.

Version 2.3.6, February 2012
* Source code maintenance.
* Documentation updates.

Version 2.3.5, December 2011
* Fix issues in 2.3.4.
* Source code maintenance.
* Documentation updates.

Version 2.3.4, November 2011
* Fix issues in 2.3.3.
* Source code maintenance.
* Documentation updates.

Version 2.3.3, October 2011
* Add code clause.
* Fix issues in 2.3.2.
* Source code maintenance.
* Documentation updates.

Version 2.3.2, October 2011
* Fix issues in 2.3.1.
* Source code maintenance.
* Documentation updates.

Version 2.3.1, September 2011
* Add building on NetBSD.
* Fix minor issues in 2.3.0.
* Lint-free source code.

Version 2.3.0, September 2011
* Implements ghost elements for empty rows.
* Implements non-local environs.
* Fix issues in 2.2.0.
* Update documentation.

Version 2.2.0, July 2011
* Improve the parser.
* Improve handling of unclosed files.
* Add compilation of uniting.
* Add routine grep in substring.
* Fix minor issues in 2.1.2.
* Update documentation.

Version 2.1.2, January 2011
* Update documentation.
* Fix reported problem in version 2.1.1.

Version 2.1.1, January 2011
* Add configuration options to configure script.
* Update the documentation.
* Fix reported problems in version 2.1.0.
* Improve error messages for options to a68g.

Version 2.1.0, January 2011
* Upgrades to the GNU build system using autoconf and automake.
* Update the memory management system.
* Add compilation of basic integer-case-clauses.
* Add compilation of LONG INT and LONG REAL units.
* Add optimisation options -O0, -O1, -O2 and -O3.
* Add option --clock.
* Fix reported problems in version 2.0.3.

Version 2.0.3, November 2010
* Add compilation of basic loops; complex loops are interpreted.
* Fix reported build problem on platforms without the GNU Scientific Library.

Version 2.0.2, November 2010
* Add option --script.
* Add Algol 68 comment syntax for shell interpreter call.
* Update documentation.
* Regression fixes:
1. A buffering problem could occur when using routines --set or --backspace
2. Some minor errors in the compiler

Version 2.0.1, September 2010
* Fix minor inconsistencies between source code and documentation.

Version 2.0.0, September 2010
* Add compiler for units to speed execution.
* Add options --optimise and --no-optimise.
* Add options --compile and --no-compile.
* Add options --object and --no-object.
* Add option --strict.
* Improve parser.
* Improve diagnostics.
* Update documentation.
* Regression fixes:
  1. Zero-suppression sometimes failed in formatted transput.
  2. The default draw fill style was 1, not 0 as stated in the manual.

Version 1.18.0, August 2009
* Regression fixes:
  1. Rowing failed for some flexible rows.
  2. Generator failed for some structures.
  3. Garbage collector could crash under rare circumstances.
  4. Some flexible mode declarations were not accepted.
  5. Some modes were incorrectly marked as equivalent.
  6. Unnecessary size limitations in some matrix operations.
  7. Build error on Mac OS X.
  8. Alignment error on AMD64.
* Add field-selections as an alternative to selections.
* Add NEW as alternative to HEAP.
* More efficient use of memory during compilation.
* Documentation updates.
* Upon request, re-post the HTML translation of the Revised Report.
* Change to a common Linux-style version numbering
  (former Mark j will now read Version 1.j.0, and 
   former Mark j.k will now read Version 1.j.k)

Version 1.17.0, May 2009
* Add C-style placeholders in formats.
* Add warnings when tags hide declarations with larger reach.
* Regression fixes:
  1. The while-part range was not visible from deeper ranges in case 
     a loop-clause was the sole unit of a routine-text.
  2. SKIP did not generate a value for some modes.
* Lint-free source code.
* Documentation updates.

Version 1.16.0, April 2009
* Regression fixes.
* Documentation updates:
  1. Add Revised Report to the LaTeX documentation.
  2. Discontinues HTML translation of the Revised Report.

Version 1.15.1, January 2009
* Add Laplace transform.
* Regression fixes and documentation updates.

Version 1.15.0, December 2008
* Regression fixes and documentation updates.
* Improve diagnostics.

Version 1.14.1, November 2008
* Implements zero replicators as required by the Revised Report.
* Decommissions (undocumented) VMS option syntax.

Version 1.14.0, October 2008
* Add first edition of the Algol 68 Genie User Manual.
* Add Revised Report (HTML translation 1.2) to the documentation.
* Add option --link to the monitor.

Version 1.13.0, June 2008
* Add procedures to interrogate files and directories.
* Add various operators and procedures.
* Add --apropos to command line options and monitor options.

Version 1.12.0, May 2008
* Improve code for the parallel clause.
* Improve interpreter efficiency.
* Improve breakpoint commands in the monitor.
* Add options UNTIL, FINISH and OUT to the monitor.
* Add Revised Report (HTML translation 1.1) to the documentation.

Version 1.11.1, March 2008
* Add options RERUN, RESET and RESTART to monitor.
* Add Revised Report (HTML translation 1.0) to the documentation.

Version 1.11.0, November 2007
* Add support for sound.
* Add Fourier transforms.
* Add pseudo operator DIAG.
* Add pseudo operator TRNSP.
* Add pseudo operator COL.
* Add pseudo operator ROW.
* Improve diagnostics in formatted transput.
* Improve monitor.

Version 1.10.2, April 2007
* Add procedure "real".
* Add format pattern 'h'.
* Add operator OP SET = (INT, L BITS) L BITS.
* Add operator OP CLEAR = (INT, L BITS) L BITS.

Version 1.10.1, December 2006
* Improve interpreter efficiency.

Version 1.10.0, August 2006
* Add basic linear algebra.
* Add procedures "arctan2", "long arctan2" and "long long arctan2".
* Add procedure "execve output".
* Improve diagnostics.
* Add option --no-backtrace.

Version 1.9.2, July 2006
* Add typographical display features.

Version 1.9.1, May 2006
* 64-bit safe interpreter.
* Improve monitor/debugger.
* Add option --monitor (or --debug).
* Add procedure "monitor".

Version 1.9.0, March 2006
* Add basic PostgreSQL support.
* Add procedure "utc time" (UNIX).
* Add procedure "local time" (UNIX).
* Improve diagnostic messages.

Version 1.8.1, November 2005
* Add procedure "sub in string" (UNIX).
* Add option --portcheck cf. standard hardware representation.
* Add option --pedantic.

Version 1.8.0, July 2005
* Add procedure "http content" (UNIX).
* Add procedure "tcp request" (UNIX).
* Add procedure "grep in string" (UNIX).
* Add procedure "last char in string".
* Add procedure "string in string".
* Add keyword UNTIL to implement post checked loop.
* Add keyword DOWNTO to complement TO.
* Add keyword ANDTH as alternative for ANDF and keyword OREL as alternative for ORF.
* Makes ~ a SKIP when used as a unit (cf. RR).

Version 1.7.0, May 2005
* Add partial parameterisation similar to C. H. Lindsey's proposal.
* Add elementary and trigonometric functions for complex numbers, independent of GSL.

Version 1.6.0, March 2005
* Add parallel clause on platforms that support POSIX threads.

Version 1.5.0, October 2004
* Improve interpreter efficiency.
* Add transput on STRING as well as FILE and PIPE.
* Add dynamic scope checking.
* Add basic preprocessor.
* Add curses support.

Version 1.4.0, June 2004
* Add more GSL support.
* Add modes LONG BITS and LONG LONG BITS.
* Makes parser accept ( .. ) as alternative for [ .. ].
* Makes parser optionally treat { .. }, [ .. ] and ( .. ) as equivalent.
* Makes parser accept loop clause as encloses clause.
* Makes mode checker accept UNION with components relates through deflexing.
* Change to thread safe plotutils interface.

Version 1.3.2, March 2004
* Add overflow checks for primitive modes.

Version 1.3.1, January 2004
* Add optional system stack overflow handling to interpreter.
* Improve multiprecision library.

Version 1.3.0, September 2003
* Add formatted transput.
* Improve speed of multiprecision library.

Version 1.2.0, March 2003
* Add mode BYTES and LONG BYTES.
* Add mode FORMAT and parsing of FORMAT texts.
* Add straightening in unformatted transput.
* Add mode PIPE and UNIX support.
* Change to UNIX system level IO.

Version 1.1.0, November 2002

Version 1.0.0, September 2002

Beta releases from November 2001 onward.
